/*
** lcd.h
**
** LCD 3310 driver
** Target: ATMEGA :: AVR-GCC
**
** Written by Tony Myatt - 2007
** Quantum Torque - www.quantumtorque.com
*/
#ifndef _NOKIALCD_H_
#define _NOKIALCD_H_

/* Lcd screen size */
#define LCD_X_RES 102
#define LCD_Y_RES 72
#define LCD_CACHE_SIZE ((LCD_X_RES * LCD_Y_RES) / 8)


/* Pinout for LCD */
#define LCD_CLK_PIN (1<<PA4)
#define LCD_DATA_PIN (1<<PA3)
#define LCD_DC_PIN (1<<PA2)
#define LCD_CE_PIN (1<<PA1)
#define LCD_RST_PIN (1<<PA0)
#define LCD_PORT PORTA
#define LCD_DDR DDRA

/* Special Chars */
#define ARROW_RIGHT	ICON(0)
#define ARROW_LEFT 	ICON(1)
#define ARROW_UP 	ICON(2)
#define ARROW_DOWN 	ICON(3)
#define STOP 		ICON(4)
#define PLAY	 	ICON(5)

/* Function for my special characters */
#define	ICON(x)		'z'+1+x

void lcd_init(void);
void lcd_contrast(unsigned char contrast);
void lcd_clear(void);
void lcd_clear_area(unsigned char line, unsigned char startX, unsigned char endX);
void lcd_clear_line(unsigned char line);
void lcd_goto_xy(unsigned char x, unsigned char y);
void lcd_goto_xy_exact(unsigned char x, unsigned char y);
void lcd_chr(char chr);
void lcd_str(char* str);

/* The Buttons */

#define B1 (1 << PC2)
#define B2 (1 << PC3)
#define B3 (1 << PC4)
#define B4 (1 << PC5)
#define B5 (1 << PC6)
#define B6 (1 << PC7)
#define BUTTON_PORT PORTC
#define BUTTON_DDR DDRC
#define BUTTON_PIN PINC


// mesaj de inceput
void ecran_init();

// afisare
void display();

// creare piesa
void create_car();
void init_player(); 
int collision();
void get_car(int *x, int *y);

// miscare piesa
int go_down();
int go_right();
int go_left();

void ecran_clear();

// final joc
void ecran_end_game();


#endif



