/*
 * Didii Theodor-Cosmin
 * Retro Car Game
 * */
 
#include <avr/io.h>
#include <avr/interrupt.h>
#include <util/delay.h>
#include <avr/pgmspace.h>
#include <stdio.h>
#include "lcd.h"

/* Functia which_button() verifica daca un buton este apasat si care anume. */
int which_button()
{
	if((BUTTON_PIN & B2) == 0)
		return 2;
	if((BUTTON_PIN & B3) == 0)
		return 3;
	if((BUTTON_PIN & B4) == 0)
		return 4;
	if((BUTTON_PIN & B5) == 0)
		return 5;
	if((BUTTON_PIN & B1) == 0)
		return 1;
	
	if((BUTTON_PIN & B6) == 0)
		return 6;
		
	return 0;
}

int main(void)
{	
	int button_nr;
	
	// Setup LCD
	lcd_init();
	
	// afisare mesaj initial "Press Button 1"
	ecran_init();
	display();
	
	// astept apasare buton 1
	while (1) {
		button_nr = which_button();
		if (button_nr == 1)
			break;
	}
	
	_delay_ms(25000);
	ecran_clear();
	lcd_clear();
	
	// creez masina
	create_car();
	get_car(NULL, NULL);
	display();
	_delay_ms(10000);
	init_player();
	// jocul efectiv
	while (1) {
		
		display();
	
		// se testeaza daca butoanele sunt apasate
		int rc = which_button();
		
		if (rc == 0)	// nu a fost apasat un buton
		{
			//masininile coboara
			int possible = go_down();
			// 
			if (possible == 0) {
				create_car();
				get_car(NULL, NULL);
				if (collision(0, 0)) {
					ecran_end_game();
					display();
					break;
				}
			}
			
		}
		else
			
		if (rc == 2)	// a fost apasat butonul pentru mutare stanga
			go_left();
		else	
		if (rc == 3)	// a fost apasat butonul pentru mutare dreapta
			go_right();
		else	
		if (rc == 5) // buton de resetare joc =>
		{
			ecran_clear();
			lcd_clear();
	
			// creez masina
			init_player();
			create_car();
			get_car(NULL, NULL);
			display();
			_delay_ms(10000);
			continue;
		}	
			
		_delay_ms(90000);
	}
	
	while (1);
	
	return 0;
}